/**
   @file

   Prototype to explore the programming of gtk (graphical
   interface). Compused of various online-stuff.
*/

#include <time.h>
#include <math.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <glib.h>

#define CENTER 150
#define LENGTH 100

GtkWidget *spinner_app;


static gboolean delete_event( GtkWidget *widget,
                        GdkEvent  *event,
                        gpointer   data )
{
gtk_main_quit ();
return FALSE;
}


static draw_spinner()
{
 double points[4];
 double angle;
 gint m_line = 0;
 gint m_color_i = 0;
 gint delay_i = 50; 

 GtkWidget * drawing_area = (GtkWidget *) spinner_app;
 GdkDrawable *drawable;
 drawable = drawing_area->window;

 /*while(TRUE)
   {	*/
 gdk_draw_line(drawable,                       
 drawing_area->style->black_gc,
 1,1,
 1,20);
 //	}


 /*






while(TRUE)
	{	
	
	angle =  m_line * M_PI / 30.0;

	points[0] = CENTER + LENGTH / 2;
	points[1] = CENTER - LENGTH / 2;
	points[2] = CENTER + (LENGTH * sin (angle));
	points[3] = CENTER - (LENGTH * cos (angle));


	if ( 0 == m_color_i )
	{
	gdk_draw_line(drawable,                       
		drawing_area->style->black_gc,
		points[0],points[1],
		points[2],points[3]);
	}
	else
	{
	gdk_draw_line(drawable,                       
		drawing_area->style->white_gc,
		points[0],points[1],
		points[2],points[3]);
	}

	if (++m_line == 60)
	{
		m_line = 0;

		if (++m_color_i == 2)
		{
			m_color_i = 0;
		}
	}
	
	
usleep(20);	

	}

 */
}



void my_callback(GtkWidget *widget, gpointer data)
{
 g_print("Ende\n");
 printf("Ende2\n");
 gtk_main_quit();
}


void drawrobot(GtkWidget *widget, int x, int y, int ox, int oy) {
  int hight = 110;
  int width = 110;

  int hwidth = 10 * hight / 100;
  int wwidth = 10 * width / 100;

  int x0 = x * (width - wwidth) / 100;
  int x1 = x0 + wwidth;
  int y0 = ((y * (hight - hwidth) / 100) - hight) * (-1);
  int y1 = y0 + hwidth;



  /*  gdk_window_constrain_size(widget->window,
			    GDK_HINT_RESIZE_INC |
			    GDK_HINT_MIN_SIZE |
			    GDK_HINT_BASE_SIZE,
			    width,
			    height,
			    &new_width,
			    &new_height);

  width = (int) new_width;
  height = (int) new_height;*/
  /*  gdk_window_clear_area(widget->window, 
			0,0,
			width, height);*/
  /*  gdk_window_hide(widget->window);
      gdk_window_show(widget->window);*/
  //  gdk_window_get_update_area(widget->window);
  //  gtk_widget_queue_draw(widget);
  //  gtk_widget_queue_clear(widget);
  //  gtk_widget_draw(widget, NULL);
  //  gdk_window_clear(widget->window);

  /*  gdk_draw_rectangle(widget->window,
		     widget->style->white_gc,
		     1,
		     0,0,
		     width, height);
  */



  gdk_draw_rectangle(widget->window,
		     widget->style->white_gc,
		     1,
		     0,0,
		     width, hight);



  gdk_draw_line(widget->window,
		widget->style->black_gc,
		x0,0,
		x0,hight);
  gdk_draw_line(widget->window,
		widget->style->black_gc,
		x1,0,
		x1,hight);


  gdk_draw_line(widget->window,
		widget->style->black_gc,
		0,y0,
		width,y0);
  gdk_draw_line(widget->window,
		widget->style->black_gc,
		0,y1,
		width,y1);

  gdk_draw_rectangle(widget->window,
		     widget->style->black_gc,
		     1,
		     x0,y0,
		     wwidth, hwidth);
}



void my_redraw(GtkWidget *widget, gpointer data)
{
  drawrobot(widget, 10, 50, 0, 0);
  

  /* gdk_draw_line(widget->window,                       
 widget->style->black_gc,
 1,1,
 1,20);*/
}


static gint
motion_notify_event (GtkWidget *widget, GdkEventMotion *event)
{
  int x, y;
  GdkModifierType state;

  if (event->is_hint)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
    }
    
  if (state & GDK_BUTTON1_MASK)
    gdk_draw_point(widget->window,                       
		  widget->style->black_gc,
		  x,y);
  
  return TRUE;
}



void check_button_press_cb(GtkWidget *widget, gpointer data)
{
 if(strcmp("Button 1", (char *)data) == 0)
   g_print("Button 1 wurde gedrckt\n");
 else if(strcmp("Button 2", (char *)data) == 0)
   g_print("Button 2 wurde gedrckt\n");
 else if(strcmp("Button 3", (char *)data) == 0)
   g_print("Button 3 wurde gedrckt\n");
 else if(strcmp("Button 4", (char *)data) == 0)
   g_print("Button 4 wurde gedrckt\n");
 else
   g_print("%s\n",(char *)data);
}

int main( int   argc, char *argv[] )
{

 GtkWidget *button1, *button2, *button3, *button4;
 GtkWidget *table, *table2;
 GtkWidget *da;

	gint counter = 0;

	gtk_init (&argc, &argv);

 /*Buttons erstellen*/
 button1  = gtk_button_new_with_label("Button 1");
 button2  = gtk_button_new_with_label("Button 2");
 button3  = gtk_button_new_with_label("Button 3");
 button4  = gtk_button_new_with_label("Button 4");


 gtk_signal_connect(GTK_OBJECT(button1), "clicked",
                    GTK_SIGNAL_FUNC(check_button_press_cb),"Button 1" );
 gtk_signal_connect(GTK_OBJECT(button2), "clicked",
                    GTK_SIGNAL_FUNC(check_button_press_cb), "Button 2");
 gtk_signal_connect(GTK_OBJECT(button3), "clicked",
                    GTK_SIGNAL_FUNC(check_button_press_cb),"Button 3" );
 gtk_signal_connect(GTK_OBJECT(button4), "clicked",
                    GTK_SIGNAL_FUNC(check_button_press_cb), "Button 4");

 /*Tabelle erstellen... 2x2*/
 table = gtk_table_new(2,2,FALSE);
 table2 = gtk_table_new(2,2,FALSE);


	spinner_app = gtk_window_new (GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title (GTK_WINDOW (spinner_app), "Spinner");

	g_signal_connect (G_OBJECT (spinner_app), "delete_event",
		      G_CALLBACK (delete_event), NULL);

	//	gtk_container_set_border_width (GTK_CONTAINER (spinner_app), 30);


	gtk_widget_show (spinner_app);

    da = gtk_drawing_area_new ();

gtk_widget_set_events (da, GDK_EXPOSURE_MASK
			 | GDK_LEAVE_NOTIFY_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

    /* set a minimum size */
    gtk_widget_set_size_request (da, 100, 100);

    //    gtk_container_add (GTK_CONTAINER (spinner_app), da);

	//	draw_spinner();

gtk_signal_connect(GTK_OBJECT(spinner_app), "delete_event",
                   GTK_SIGNAL_FUNC(my_callback), NULL);

gtk_signal_connect(GTK_OBJECT(da), "expose_event",
                   GTK_SIGNAL_FUNC(my_redraw), NULL);

gtk_signal_connect(da, "motion_notify_event",
		      GTK_SIGNAL_FUNC(motion_notify_event), NULL);


 // gtk_container_set_border_width(GTK_CONTAINER(spinner_app),40);

 /*Inhalt der Tabelle mit verschiedenen Optionen erstellen....*/


 gtk_table_attach_defaults(GTK_TABLE(table2), button1, 0,1, 0,1);
 gtk_table_attach_defaults(GTK_TABLE(table2), button2, 0,1, 1,2);
 gtk_table_attach_defaults(GTK_TABLE(table2), button3, 1,2, 0,1);
 gtk_table_attach_defaults(GTK_TABLE(table2), button4, 1,2, 1,2);


 gtk_table_attach_defaults(GTK_TABLE(table), da, 0,1, 0,1);
 gtk_table_attach_defaults(GTK_TABLE(table), table2, 0,1, 1,2);


 gtk_container_add(GTK_CONTAINER(spinner_app),table);

 /*Zeigs uns.....*/
 gtk_widget_show_all(spinner_app);



	gtk_main ();

    return 0;
}


